Package net.sf.saxon.serialize

## Class AdaptiveEmitter

- java.lang.Object
- - net.sf.saxon.event.SequenceReceiver
  - - net.sf.saxon.event.SequenceWriter
    - - net.sf.saxon.serialize.AdaptiveEmitter

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`, `ReceiverWithOutputProperties`

      public class AdaptiveEmitter
      extends SequenceWriter
      implements ReceiverWithOutputProperties

  This class implements the Adaptive serialization method defined in XSLT+XQuery Serialization 3.1.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.SequenceReceiver

      `pipelineConfiguration, previousAtomic, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AdaptiveEmitter​(PipelineConfiguration pipe, java.io.Writer writer)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Notify the end of the event stream
    `java.util.Properties` | `getOutputProperties()` | Get the serialization properties maintained by this `Receiver`
    `void` | `setCharacterMap​(CharacterMap map)` | Set the CharacterMap to be used, if any
    `void` | `setNormalizer​(Normalizer normalizer)` | Set the Unicode normalizer to be used for normalizing strings.
    `void` | `setOutputProperties​(java.util.Properties props)` |
    `void` | `write​(Item item)` | Abstract method to be supplied by subclasses: output one item in the sequence.

    - ### Methods inherited from class net.sf.saxon.event.SequenceWriter

      `append, characters, comment, endDocument, endElement, getTreeModel, processingInstruction, setTreeModel, setUnparsedEntity, startDocument, startElement, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.SequenceReceiver

      `append, decompose, flatten, getConfiguration, getErrorCodeForDecomposingFunctionItems, getNamePool, getPipelineConfiguration, getSystemId, handlesAppend, open, setPipelineConfiguration, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `append, append, characters, comment, endDocument, endElement, getPipelineConfiguration, handlesAppend, open, processingInstruction, setPipelineConfiguration, setSystemId, setUnparsedEntity, startDocument, startElement, usesTypeAnnotations`

    - ### Methods inherited from interface javax.xml.transform.Result

      `getSystemId`

- - ### Constructor Detail

    - #### AdaptiveEmitter

          public AdaptiveEmitter​(PipelineConfiguration pipe,
                                 java.io.Writer writer)

  - ### Method Detail

    - #### setOutputProperties

          public void setOutputProperties​(java.util.Properties props)

    - #### setNormalizer

          public void setNormalizer​(Normalizer normalizer)

      Set the Unicode normalizer to be used for normalizing strings.
      Parameters:
        `normalizer` - the normalizer to be used

    - #### setCharacterMap

          public void setCharacterMap​(CharacterMap map)

      Set the CharacterMap to be used, if any
      Parameters:
        `map` - the character map

    - #### getOutputProperties

          public java.util.Properties getOutputProperties()

      Description copied from interface: `ReceiverWithOutputProperties`
      Get the serialization properties maintained by this `Receiver`
      Specified by:
        `getOutputProperties` in interface `ReceiverWithOutputProperties`
      Returns:
        the serialization properties

    - #### write

          public void write​(Item item)
                     throws XPathException

      Abstract method to be supplied by subclasses: output one item in the sequence.
      Specified by:
        `write` in class `SequenceWriter`
      Parameters:
        `item` - the item to be written to the sequence
      Throws:
        `XPathException` - if any failure occurs while writing the item

    - #### close

          public void close()
                     throws XPathException

      Description copied from interface: `Receiver`
      Notify the end of the event stream
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `SequenceWriter`
      Throws:
        `XPathException` - if an error occurs